
library(Sparameters)
data(exampleData)
attach(exampleData, warn=FALSE)

d <- 5.0e-3 # thickness
cel <- 299792458 # m/s

paper <- effectiveMedium(frequency, S11, S21, d=5e-3, n=0)
# 
# par(mfrow=c(1, 2))
# 
# with(paper, matplot(frequency, cbind(Re(epsilon), Im(epsilon)), type="l", lty=1:2, col=1:2,
#                         xlab="frequency [Hz]", ylab=expression(epsilon)))
# with(paper, matplot(frequency, cbind(Re(mu), Im(mu)), type="l", lty=1:2, col=1:2,  
#                         xlab="frequency [Hz]", ylab=expression(mu)))
# legend("topright", lty=1:2, col=1:2, legend=c("Re", "Im"), bty="n")

attach(paper, warn=FALSE)

test0 <- with(effectiveMedium(frequency, S11, S21, d=5e-3, n = 0), {
        # calculate n1
        n1 <- sqrt(epsilon*mu)*Re(sqrt(epsilon/mu))
        n <- {if (length(n1[Im(n1) < 0]) > length(n1[Im(-n1) < 0])) -n1
        else n1 }
}
)
test1 <- with(effectiveMedium(frequency, S11, S21, d=5e-3, n=1), {
        # calculate n1
        n1 <- sqrt(epsilon*mu)*Re(sqrt(epsilon/mu))
        n <- {if (length(n1[Im(n1) < 0]) > length(n1[Im(-n1) < 0])) -n1
        else n1 }
}
)

par(mfrow=c(1, 2))
matplot(frequency, cbind(Re(test0), Re(test1)), type="l", ylab="n")
matplot(frequency, cbind(Im(test0), Im(test1)), type="l", ylab="k")